package eu.dnetlib.validatorapi.entities;

import javax.persistence.*;
import java.io.Serializable;

@Entity
@Table(name="validation_results")
@IdClass(ValidationRuleResult.class)
public class ValidationRuleResult implements Serializable {

    @Id
    @Column(name = "validation_job_id")
    public int validationJobId;

    @Id
    @Column(name = "rule_name")
    public String ruleName;

    @Id
    @Column(name = "rule_weight")
    public int ruleWeight;

    @Id
    @Column(name = "record_url")
    public String recordUrl;

    @Column(name = "internal_error")
    public String internalError;

    @Column(name = "status")
    public String status;

    @Column(name = "score")
    public double score;

    @Column(name = "has_errors")
    public boolean hasErrors;

    @Column(name = "hasWarnings")
    public boolean hasWarnings;

    public ValidationRuleResult() {}


    @Override
    public String toString() {
        return "ValidationRuleResult{" +
                "validationJobId=" + validationJobId +
                ", ruleName='" + ruleName + '\'' +
                ", ruleWeight=" + ruleWeight +
                ", recordUrl='" + recordUrl + '\'' +
                ", internalError='" + internalError + '\'' +
                ", status='" + status + '\'' +
                ", score=" + score +
                ", hasErrors=" + hasErrors +
                ", hasWarnings=" + hasWarnings +
                '}';
    }
}

