package eu.dnetlib.validatorapi.processors;

import eu.dnetlib.validatorapi.entities.ValidationJob;
import eu.dnetlib.validatorapi.repositories.ValidationJobRepository;
import eu.dnetlib.validatorapi.repositories.ValidationResultRepository;
import org.apache.camel.Exchange;
import org.apache.camel.Processor;

import java.util.Date;

public class DataBaseProcessor implements Processor {
    private final ValidationJob validationJob;
    private final ValidationJobRepository validationJobRepository;
    private final ValidationResultRepository validationResultRepository;

    public DataBaseProcessor(ValidationJob validationJob, final ValidationJobRepository validationJobRepository,
                             final ValidationResultRepository validationResultRepository){
        this.validationJob = validationJob;
        this.validationJobRepository = validationJobRepository;
        this.validationResultRepository = validationResultRepository;

    }

    @Override
    public void process(Exchange exchange) throws Exception {
        validationJob.progress = "COMPLETED";
        validationJob.endDate = new Date();
        validationJob.status = validationResultRepository.getStatus(validationJob.id);
        System.out.println(validationJob.status);
        validationJobRepository.save(validationJob);
    }
}
